import java.awt.*;
import javax.swing.JPanel;

public class FontMetricsTestPanel extends JPanel {
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;
	//
	Font font;
	//
	String[] strings=new String[]{
		"Hannibal ad portas (ˌɃnjoĂ)",
		"Alea jacta est (΂͓ꂽI)",
		"Cogito ergo sum (vÂɉ䂠)"
	};
	//
	public FontMetricsTestPanel(int size){
		//
		font=new Font(null,Font.PLAIN,size);
	}
	public void setFontSize(int size){
		//
		font=new Font(null,Font.PLAIN,size);
	}
	//
	public void paintComponent(Graphics g){
		super.paintComponent(g);
		//
		g.setFont(font);
		//
		FontMetrics metrics=g.getFontMetrics();
		int ascent=metrics.getAscent();
		int descent=metrics.getDescent();
		int leading=metrics.getLeading();
		int height=metrics.getHeight();
		//
		int drawLine=100;
		for(int s=0;s<strings.length;s++){
			g.setColor(Color.RED);
			g.drawLine(0,drawLine,getWidth(),drawLine);
			g.drawLine(0,drawLine-ascent,getWidth(),drawLine-ascent);
			g.drawLine(0,drawLine+descent,getWidth(),drawLine+descent);
			g.drawLine(0,drawLine+descent+leading,getWidth(),drawLine+descent+leading);
			//
			g.setColor(Color.BLACK);
			g.drawString(strings[s],50,drawLine);
			//
			drawLine+=height;
		}
		//
		g.setFont(new Font(null,Font.PLAIN,20));
		g.drawString("ascent:"+ascent+" descent:"+descent+" leading:"+leading+" height:"+height,50,getHeight()-10);
	}
}
